import { world, system } from "@minecraft/server";
import * as mc from '@minecraft/server';

world.afterEvents.entityDie.subscribe(event => {
	const player = event.deadEntity
	if (player.typeId != "minecraft:player") return;
	const name = player.nameTag
	let hex_name = convert_hex(name);
	const cause = event.damageSource.cause
	const damager = event.damageSource.damagingEntity
	if(!damager) return;
	try {
		const ind = "mba:item_head_" + hex_name
		const head = new mc.ItemStack(ind, 1);
		if(damager.nameTag){head.setLore([`Killed by: ${damager.nameTag}`])} else{
			const typeid = damager.typeId
			const dName = typeid.split(":")
			head.setLore([`Killed by: ${dName[1]}`])
		}
		player.dimension.spawnItem(head, player.location);
	} catch ( error ) {
		player.sendMessage(`§c${name}\'s head dosn\'t exist in the pack`)
	}
});

world.beforeEvents.chatSend.subscribe((eventData) => {
    const player = eventData.sender;
    let message = eventData.message;
	if (!message.startsWith(";head ")) return;
	eventData.cancel = true;
    message = message.replace(';head ', '');
	if (!message) return;
	let hex_name = convert_hex(message)
	const head = "mba:item_head_" + hex_name
	system.run(() => {
		try {player.runCommand(`give @s[m=c] ${head}`)}
		catch ( error ) {player.sendMessage(`§c"${message}" head dosn\'t exist in the pack, or you are not in Creative mode`)}
	})
});

function convert_hex(name){
	let hex_name = '';
	for (let i = 0; i < name.length; i++){hex_name += name.charCodeAt(i).toString(16)}
	return hex_name
}